package za.org.coefficient.modules.sample;

import java.util.HashMap;

import za.org.coefficient.authentication.Role;
import za.org.coefficient.core.Project;
import za.org.coefficient.interfaces.CoefficientContext;
import za.org.coefficient.modules.BaseModule;
import za.org.coefficient.util.ejb.SecurityUtil;
import za.org.coefficient.util.ejb.VelocityScreenUtil;

/**
 * @pojo2ejb.class 
 *   name="Wiki"
 *   jndi-prefix="za/org/coefficient/navigation/"
 *   interface-extends="za.org.coefficient.interfaces.Module"
 *   interface-local-extends="za.org.coefficient.interfaces.ModuleLocal"
 *
 */
public class Wiki extends BaseModule {
    
    private String wikiText;
	
    public Wiki() {
      wikiText = "This is a *wiki* _page_ ";
    }
    
    public String getModuleDisplayName () {
        return "Wiki";
    }

    public String getModuleDescription () {
        return "Sample Module";
    }

    public String getMainMethod () {
        return "display";
    }

    public void display (CoefficientContext ctx) {
      HashMap map = new HashMap();
      
      String result = wikiText.
        replaceAll(" \\*"," <b>").
	replaceAll("\\* ","</b> ").
	replaceAll(" _","<i> ").
	replaceAll("_ "," </i>").
	replaceAll("\\\\","<br/>");
      
      map.put("wikiText", result);
      StringBuffer sb =
        VelocityScreenUtil.getProcessedScreen("display.vm", map);
      ctx.setModuleContent (sb.toString(), getModuleName());
   }

   public void updateForm (CoefficientContext ctx) {
      HashMap map = new HashMap();
      map.put("wikiText", wikiText);
      StringBuffer sb =
        VelocityScreenUtil.getProcessedScreen("updateForm.vm", map);
      ctx.setModuleContent (sb.toString(), getModuleName());
   }

   public void update (CoefficientContext ctx) {
     wikiText = ctx.getParameter("wikiText");
     ctx.setForward("Wiki","display");
   }
}

